#!/bin/bash

exec 3< config.h
while 
  read -u 3 CMD MACRO PAR
do
  if test "$CMD" == "#define"
  then
    if test "$PAR" == ""
    then
      PAR="(null)"
    fi
    eval $MACRO="$PAR"
  fi
done
exec 3<&-


IFS=
DISCARD=0
while 
  read LINE
do
  if test "${LINE:0:7}" == "#ifdef "
  then
    ARG="${LINE#* }"
    eval test -n "\"\$$ARG\""
    if (($? != 0))
    then
      DISCARD=1
    fi
  elif test "${LINE:0:5}" == "#else"
  then
    ((DISCARD=1 - DISCARD))
  elif test "${LINE:0:6}" == "#endif"
  then
    DISCARD=0
  elif ((DISCARD == 0))
  then
    echo "$LINE"
  fi
done

