/*
  intelhex.h
  Matlib 2010-10-19
*/


#ifndef _INTELHEX_H

#define _INTELHEX_H 1

#include <inttypes.h>

struct memory_block;
struct memory_block
{
  uint32_t start, length;
  struct memory_block *next;
  unsigned char data [0];
};
typedef struct memory_block *MemoryBlock;


static int ih_new (MemoryBlock *blk, uint32_t start, uint32_t length);
static void ih_free (MemoryBlock *blks);
static int ih_loadfile (char *name, MemoryBlock *blks);
static int ih_savefile (char *name, MemoryBlock blks);

#endif

